<?php

namespace App\Controller\Admin;

use App\Entity\CollectifData;
use App\Entity\Configuration;
use App\Type\DreamsType;
use App\Type\ProjectsBoostType;
use App\Type\ProjectsInspiringType;
use App\Type\RevoltsType;
use Doctrine\ORM\EntityManagerInterface;
use EasyCorp\Bundle\EasyAdminBundle\Field\AssociationField;
use EasyCorp\Bundle\EasyAdminBundle\Field\IntegerField;
use Lc\SovBundle\Controller\Admin\AbstractCrudController;
use Lc\SovBundle\Field\CollectionField;
use Lc\SovBundle\Field\StatusField;

class CollectifDataCrudController extends AbstractCrudController
{
    public static function getEntityFqcn(): string
    {
        return CollectifData::class;
    }

    public function configureFields(string $pageName): iterable
    {
        return [
            AssociationField::new('territory'),
            IntegerField::new('nbParticipant'),
            CollectionField::new('revolts')
                ->setFormTypeOption('entry_type', RevoltsType::class)
                ->setFormTypeOption('mapped', true)
                ->setRequired(false),
            CollectionField::new('dreams')
                ->setFormTypeOption('entry_type', DreamsType::class)
                ->setRequired(false),
            CollectionField::new('projectsboost')
                ->setFormTypeOption('entry_type', ProjectsBoostType::class)
                ->setRequired(false),
            CollectionField::new('projectsinspiring')
                ->setFormTypeOption('entry_type', ProjectsInspiringType::class)
                ->setRequired(false),
            StatusField::new('status')->setRequired(false)
        ];
    }

    public function persistEntity(EntityManagerInterface $entityManager, $entityInstance): void
    {
        $entityInstance->setUser($this->getUser());
        dump($entityInstance);
        die;
        $entityManager->persist($entityInstance);
        $entityManager->flush();

        parent::persistEntity($entityManager, $entityInstance);
    }
}
